<?php class shipmentdestination extends baseobject { 
	
	protected static $fields=array(
		'name'=>validator::REQUIRED,
	    'interfaceclass'=>validator::REQUIRED,
	    'shipmentsubmiturl'=>validator::ANY,
	    'authenticateurl'=>validator::ANY
	);
	
	protected static $helpTexts=array(
		'name'=>'The name of the shipment destination',
	    'interfaceclass'=>'How Icebear talks to this destination',
	    'shipmentsubmiturl'=>'The URL where shipments are submitted',
	    'authenticateurl'=>'The URL where users authenticate'
	);
	
	public static function canCreate(){
		if(session::isAdmin()){ return true; }
		$grp=usergroup::getByName(usergroup::SHIPPERS);
		if(usergroup::userisingroup($grp['id'])){ return true; }
		$grp=usergroup::getByName(usergroup::TECHNICIANS);
		return usergroup::userisingroup($grp['id']);
	}
	
	public static function getshipments($id, $request=array()){
	    return shipment::getByProperty('shipmentdestinationid', $id, $request);
	}
	
}

?>