<!DOCTYPE html>
<html>
<head>
	<title><?php echo $pageTitle; ?></title>
	<meta charset="utf-8"/>
	<script type="text/javascript" src="/js/prototype1_7_2.js"></script>
	<script type="text/javascript" src="/js/prototype1_7_2_http_fix.js"></script>
	<script type="text/javascript" src="/js/client.js?t=<?php echo @filemtime($wwwroot.'/client/js/client.js'); ?>"></script>
	<script type="text/javascript" src="/js/ui.js?t=<?php echo @filemtime($wwwroot.'/client/js/ui.js'); ?>"></script>
	<script type="text/javascript">
	var currentUser=<?php echo json_encode(session::getUser()); ?>;
	var username="<?php echo session::getUsername(); ?>";
	var userId=<?php echo session::getUserId(); ?>;
	var csrfToken="<?php echo session::get('csrfToken'); ?>";
	UserConfig.items=<?php echo json_encode($userConfig); ?>;
	var skin=UserConfig.get("skin","default");
	var theme="light"; //Or dark. LATER From skin metadata
	var helpTexts=<?php echo (isset($helpTexts)) ? json_encode($helpTexts) : 'null' ; ?>;
	var fieldValidations=<?php echo (isset($fieldValidations)) ? json_encode($fieldValidations) : 'null' ; ?>;
	var validationPatterns=<?php echo (isset($validationPatterns)) ? json_encode($validationPatterns) : 'null' ; ?>;
	var submitTimer;
	var data=<?php echo isset($data) ? json_encode($data) : 'null'; ?>;
	var pageTitle="<?php echo $pageTitle ?>";
	var initialHash=document.location.hash;
	<?php if(session::isLoggedIn()){
		$isAdmin=session::isAdmin();
		echo 'var sharedProject='.json_encode(project::getByName(project::SHARED)).";\n";
		echo 'var isAdmin='.($isAdmin?'true':'false').";\n";
		if(null==session::get('isTechnician')){
			try {
				$techniciansGroup=usergroup::getByName(usergroup::TECHNICIANS);
				$isTechnician=usergroup::userisingroup($techniciansGroup['id']);
			} catch (Exception $e){
				$isTechnician=false;	
			}
			session::set('isTechnician', $isAdmin || $isTechnician);
		}
		echo 'var isTechnician='.($isAdmin || session::get('isTechnician')?'true':'false').";\n";
		if(null==session::get('isShipper')){
			try {
				$shippersGroup=usergroup::getByName(usergroup::SHIPPERS);
				$isShipper=usergroup::userisingroup($shippersGroup['id']);
			} catch (Exception $e){
				$isShipper=false;	
			}
			session::set('isShipper', $isAdmin || $isShipper);
		}
		echo 'var isShipper='.($isAdmin || session::get('isShipper')?'true':'false').";\n";
	} ?>
	<?php if(isset($canUpdate)){
		echo 'var canEdit='.($canUpdate ? 'true':'false').";\n"; 
	}  else {
		echo "var canEdit=true; //Default because \$canUpdate was not set by server. Permissions will be enforced server-side.\n";
	}?>

	/* TODO Extract all this to .js file */
	function doLogout(){
		new Ajax.Request('/api/Logout',{
			method:'post',
			onSuccess:doLogout_onSuccess,
			onFailure:doLogout_onFailure
		});
	}
	function doLogout_onSuccess(transport){
		document.location="/";
	}
	function doLogout_onFailure(transport){
		alert("Could not log out\n\n"+transport.responseText);
	}


	function updateAjaxSearchBox(elem,event){
		if(null!=event && event.keyCode){
			var k=event.keyCode;
			if(37==k || 39==k){ return; } //left/right arrow
			if(38==k){ ajaxSearchSelectPrevious(); return; } //Up arrow
			if(40==k){ ajaxSearchSelectNext(); return; } //Down arrow
			if(13==k){ ajaxSearchGoToSelected(); return; } //Enter
			if(27==k){ stopAjaxSearch(); return; } //Escape
		}
		elem=$(elem);
		var regex=/^[A-za-z0-9_-]*$/g;
		var terms=elem.value.trim();
		if(""==terms || !terms.match(regex)){ return false; }
		if(2>=terms.length){
			stopAjaxSearch(elem);
		} else if(elem.searchresults && 0<elem.searchresults.length && 0==elem.value.indexOf(elem.searchresults.searchterms)){
			ajaxSearchUpdateResults(elem);
		} else {
			ajaxSearch(elem,terms);
		}
	}
	function ajaxSearch(elem,terms){
		elem.searchterms='';
		elem.searchresults=new Array();
		if(!elem.dataset.classlist){ 
			alert("Cannot search - no list of types to search for. See an admin."); 
			return false;
		}
		elem.addClassName("updating");
		new Ajax.Request("/api/search/"+terms+"?pagenumber=1&pagesize=50&classes="+elem.dataset.classlist,{
			method:"get",
			onSuccess:function(transport){ ajaxSearch_onSuccess(transport,elem); },
			onFailure:function(transport){ ajaxSearch_onFailure(transport,elem); },
		});
	}
	function ajaxSearch_onSuccess(transport,elem){
		elem.removeClassName("updating");
		//are these results still valid?
		if(0!==elem.value.toLowerCase().indexOf(transport.responseJSON.searchterms.toLowerCase())){
			return _doAjaxSearch(elem);
		}
		elem.searchterms=transport.responseJSON.searchterms;
		elem.searchresults=transport.responseJSON.rows;
		ajaxSearchMakeResultsBox(elem);
		ajaxSearchUpdateResults(elem);
		$("searchboxresults").style.display="block";
	}
	function ajaxSearch_onFailure(transport,elem){
		if(401==transport.status){
			$("searchboxresults").style.display="none";
        	ui.handleSessionExpired();
			return;
		}
		ajaxSearchMakeResultsBox(elem);
		elem.searchresults=new Array();
		ajaxSearchUpdateResults(elem);
		$("searchboxresults").style.display="none";
	}
	function ajaxSearchMakeResultsBox(elem){
		if(!$("searchboxresults")){
			var rect=elem.getBoundingClientRect();
			var sb=document.createElement("div");
			sb.id="searchboxresults";
			sb.className="box hastable";
			document.body.appendChild(sb);
			$(sb).setStyle({
				position:"absolute",
				top:rect.bottom+"px",
				left:rect.left+"px",
				zIndex:99999,
				width:elem.getWidth()+"px",
				background:"#fff",
				border:"1px solid #666",
				overflow:"auto"
			});
		}
	}
	function ajaxSearchUpdateResults(elem){
		var rows=elem.searchresults;
		var rect=elem.getBoundingClientRect();
		var sb=$("searchboxresults");
		sb.style="position:absolute;top:"+rect.bottom+"px;left:"+rect.left+"px;z-index:99999;width:"+elem.getWidth()+"px;background:#fff;border:1px solid #666;overflow:auto";
		sb.innerHTML="<table></table>";
		var t=sb.down("table");
		while(t.down()){ t=t.down(); }
		rows.each(function(r){
			if(-1==r.name.toLowerCase().indexOf(elem.value.toLowerCase())){ return; /*from this iteration of the loop*/ }
			var tr=document.createElement("tr");
			t.appendChild(tr);
			tr.innerHTML+='<td><a href="/'+r.objecttype+'/'+r.id+'">'+r.name+'</a></td>';
		});
		sb.down("tr").addClassName("selected");
	}
	function ajaxSearchSelectPrevious(){
		var sb=$("searchboxresults");
		if(!sb){ return false; }
		var sel=sb.down(".selected");
		if(sel.previous()){
			sel.removeClassName("selected");
			sel.previous().addClassName("selected");
		}
	}
	function ajaxSearchSelectNext(){
		var sb=$("searchboxresults");
		if(!sb){ return false; }
		var sel=sb.down(".selected");
		if(sel.next()){
			sel.removeClassName("selected");
			sel.next().addClassName("selected");
		}
	}
	function ajaxSearchGoToSelected(){
		var sb=$("searchboxresults");
		if(!sb){ return false; }
		var sel=sb.down(".selected");
		sel.style.backgroundColor="orange";
		document.location.href=sel.down("a").href;
	}


	function stopAjaxSearch(elem){
		elem.removeClassName("updating");
		if($("searchboxresults")){
			window.setTimeout(function(){ $("searchboxresults").style="display:none";}, 100);
		}
	}
	
	</script>
	<?php 
    $skin=userconfig::get('skin');
    if(!$skin){ $skin="default"; }
    ?>
	<link rel="stylesheet" type="text/css" href="/skins/base.css?t=<?php echo @filemtime($wwwroot.'/client/skins/base.css'); ?>" />
	<link rel="stylesheet" type="text/css" href="/skins/client.css?t=<?php echo @filemtime($wwwroot.'/client/skins/client.css'); ?>" />
	<link rel="stylesheet" type="text/css" href="/skins/<?php echo $skin; ?>/default.css?t=<?php echo @filemtime($wwwroot.'/client/skins/'.$skin.'/default.css'); ?>" />
</head>
<body>
<div id="container">
<header id="header">
<?php if(session::isLoggedIn()){ ?>
		<a class="noprint" href="#" onclick="showMenu();return false"><img style="float:right" id="menubutton" src="/images/icons/btn_menu.png" title="Menu" alt="Menu"/></a>
		<?php 
		if(isset($objectType) && file_exists($wwwroot.'/client/help/'.$objectType.'/index.php') ){ ?>
			<a class="noprint" href="/help/<?php echo $objectType; ?>" target="_blank"><img id="helpbutton" src="/images/icons/btn_help.png" title="Get help" alt="Get help"/></a>
		<?php } ?>
		<?php if($hasConfig){ ?>
			<a class="noprint" href="#"><img id="configbutton" src="/images/icons/btn_config.png" title="Configure this page" alt="Configure this page"/></a>
		<?php } ?>
		<input class="noprint" type="text" name="headersearch" id="headersearch" data-classlist="plate,platetype,container" onfocus="updateAjaxSearchBox(this)" onkeyup="updateAjaxSearchBox(this,event)" onblur="stopAjaxSearch(this)" placeholder="Find by barcode..." />
<?php } ?>
<script type="text/javascript">
var path=document.location.pathname.substr(1).replace(/\/$/, "");
var breadcrumbs='';
var crumbParts=null;
<?php if(isset($breadcrumbs)){
	echo "crumbParts=".json_encode($breadcrumbs).";\n";
}?>
if(!userId){
	/* No breadcrumbs needed, login page */
} else if(null!=crumbParts){
	breadcrumbs+='<a class="breadcrumb" href="/"><img src="/images/icons/bc_home.png" title="Home" alt="Home"/></a>';
	crumbParts.each(function(part){
		breadcrumbs+='<a class="breadcrumb" href="'+part.url+'"><img src="/images/icons/bc_'+part.icon+'.png" title="'+part.help+'" alt="'+part.icon+'"/></a>';
	});
} else if(''!=path){
	breadcrumbs+='<a class="breadcrumb" href="/"><img src="/images/icons/bc_home.png" title="Home" alt="Home"/></a>';
	path=path.split("/");
	var objType=path[0];
	if(2<=path.length && ''!=path[1]){
		breadcrumbs+='<a class="breadcrumb" href="/'+objType+'/"><img src="/images/icons/bc_'+objType+'.png" title="'+objType+'s" alt="'+objType+'s"/></a>';
	} else {
		<?php if(isset($showCreateLink) && true==$showCreateLink){ ?>
		pageTitle+='&nbsp;&nbsp;&nbsp;&nbsp;<a style="font-size:80%;float:none;" href="/'+objType+'/create">Create new...</a>';
		<?php }?>
	}
}
document.write('<h1>'+breadcrumbs+'&nbsp;'+pageTitle);
document.write('</h1>');

if(document.getElementById("headersearch")){ 
	document.getElementById("headersearch").focus();
}
</script>
</header>
<div id="content">
