<?php $pageTitle='Shipment: '.$data['name'];
include realpath(__DIR__).'/../../core/_common/header.php'; 
$sharedProject=project::getByName(project::SHARED);
$sharedProjectId=$sharedProject['id'];
$canShip=shipment::canCreate();
?>
<script type="text/javascript">
//TODO Read-only if already shipped or non-admin/shipper/technician
var userCanShip=<?php echo $canShip ? 'true' : 'false '; ?>;

document.observe("dom:loaded",function(){
	var grid=ui.grid();

	var ts=grid.tabSet({ id:"shiptabs", classes:'r1 c1 w3 h3' });
	var detailsTab=ts.tab({
		"label":"Shipment",
		"id":"shipmentdetails"
	});
	var frm=detailsTab.form({
		action:'/api/shipment/'+data.id,
		method:'patch',
		id:'shipmentdetails_form',
		readonly:!userCanShip || ""!=data.dateshipped 
	});
	frm.hiddenField('projectid',<?php echo $sharedProjectId; ?>);
	frm.insert({bottom:'<label><h3>Shipment details</h3></label>'});
	frm.textField({ label:"Name", name:'name', value:data.name });
	frm.roleField({ 
		label:"Destination", 
		name:'shipmentdestinationid', 
		otherId:data.shipmentdestinationid, 
		otherName:data.shipmentdestinationname, 
		otherType:'shipmentdestination',
		labelField:'name',
		headers:['Name'],
		cellTemplates:['{{name}}']
	});
	frm.roleField({ 
		label:"Shipper", 
		name:'shipperid', 
		otherId:data.shipperid, 
		otherName:data.shippername, 
		otherType:'user',
		labelField:'name',
		headers:['Name'],
		cellTemplates:['{{name}}']
	});
	if(""!=data.dateshipped){
		frm.dateField({ label:"Date shipped", name:'dateshipped', value:data.dateshipped });
	}
	if(""!=data.datereturned){
		frm.dateField({ label:"Date returned", name:'datereturned', value:data.datereturned });
	}
	if(userCanShip && ""==data.dateshipped){ 
    	var frm2=detailsTab.form({
    		action:'#',
    		method:'get',
    		id:'shipmentactions_form',
    		classes:'noprint'
    	});
    	frm2.insert({bottom:'<label><h3>Add a dewar</h3></label>'});
    	frm2.textField({ label:"Scan a barcode", name:'addtoplevelbybarcode', placeholder:"Barcode" });
    	frm2.insert({bottom:'<br/><br/><br/><label><h3>Send this shipment</h3></label>'});
    	frm2.buttonField({ label:"Send shipment", onclick:Shipment.send });
    	frm2.onsubmit=function(){ Shipment.addDewarByBarcode(); return false; };
	}

	if(""!=data.manifest && data.manifest.rows){
		data.manifest.rows.each(function(row){
			Shipment.renderDewar(row);
		});
	} else {
		Shipment.getAndRenderContainers();
	}	

	//TODO accept plates
	
	
});
</script>
<?php include realpath(__DIR__).'/../../core/_common/footer.php'; ?>